<template>
    <form @submit.prevent="onSubmit">
        <div class="container">
            <div class="card shadow mb-4">
                <div
                    class="card-header bg-white py-3 d-flex flex-row align-items-center justify-content-between"
                >
                    <h3 class="m-0 font-weight-bold text-primary">
                        User Form
                    </h3>
                    <a @click="onExit" type="button"
                        ><i class="fa fa-times" aria-hidden="true"></i
                    ></a>
                </div>
                <div class="card-body px-5">
                    <div class="row align-items-center">
                        <div class="col-12 col-md-4">
                            <div class="row">
                                <div class="col-12 text-center">
                                    <img
                                        :src="dataObject.avatar"
                                        class="img-thumbnail"
                                        width="200px"
                                        height="200px"
                                        @click="
                                            disabled
                                                ? ''
                                                : $refs.fileInput.click()
                                        "
                                        :role="disabled ? '' : 'button'"
                                    />
                                    <div
                                        v-show="!disabled"
                                        class="justify-content-center mt-3"
                                    >
                                        <label
                                            class="btn btn-primary btn-sm m-1"
                                        >
                                            Browse
                                            <input
                                                type="file"
                                                accept="image/*"
                                                @change="onImageChange"
                                                ref="fileInput"
                                                hidden
                                            />
                                        </label>
                                        <button
                                            type="button"
                                            class="btn btn-secondary btn-sm m-1"
                                            @click="onImageReset"
                                        >
                                            Reset
                                        </button>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-12 col-md-8">
                            <div class="row align-items-end">
                                <div class="col-12 col-md-6">
                                    <label for="inputFirstName"
                                        >First Name</label
                                    >
                                    <input
                                        type="text"
                                        id="inputFirstName"
                                        class="form-control"
                                        v-model="dataObject.first_name"
                                        required
                                        :readonly="disabled"
                                        ref="first_name"
                                    />
                                </div>
                                <div class="col-12 col-md-6">
                                    <label for="inputLastName">Last Name</label>
                                    <input
                                        type="text"
                                        id="inputLastName"
                                        class="form-control"
                                        v-model="dataObject.last_name"
                                        required
                                        :readonly="disabled"
                                    />
                                </div>
                                <div class="col-12 col-md-6">
                                    <label for="inputNickName">Nick Name</label>
                                    <input
                                        type="text"
                                        id="inputNickName"
                                        class="form-control"
                                        v-model="dataObject.nick_name"
                                        :readonly="disabled"
                                    />
                                </div>
                                <div class="col-12 col-md-6">
                                    <label for="inputEmail">Email</label>
                                    <input
                                        type="email"
                                        id="inputEmail"
                                        class="form-control"
                                        v-model="dataObject.email"
                                        required
                                        :readonly="!isAction('create')"
                                    />
                                </div>
                                <div class="col-12 col-md-6">
                                    <label for="selectStatus">Department</label>
                                    <multi-select
                                        v-model="dataObject.department"
                                        :options="departments"
                                        track-by="id"
                                        label="name"
                                        placeholder="Select Department"
                                        :disabled="isDisabled"
                                    ></multi-select>
                                </div>
                                <div class="col-12 col-md-6">
                                    <label for="selectOwner">Role</label>
                                    <multi-select
                                        v-model="dataObject.role"
                                        :options="roles"
                                        placeholder="Select Role"
                                        :disabled="isDisabled"
                                    ></multi-select>
                                </div>
                                <div
                                    v-show="!disabled"
                                    class="col-12 col-md-2 ml-auto"
                                >
                                    <input
                                        type="submit"
                                        class="btn btn-primary btn-block"
                                        tabindex="4"
                                        :value="
                                            isAction('create')
                                                ? 'Save'
                                                : 'Update'
                                        "
                                        :disabled="disabled"
                                    />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </form>
</template>

<script>
import Swal from "sweetalert2";
import MultiSelect from "vue-multiselect";

export default {
    components: {
        MultiSelect
    },
    props: ["disabled"],
    data() {
        return {
            dataObject: {
                image: "",
                avatar: "/img/person_placeholder.jpg",
                first_name: "",
                last_name: "",
                nick_name: "",
                email: "",
                department: [],
                role: []
            },
            departments: [],
            roles: ["admin", "user"],
            isSubmit: false,
            isDisabled: this.action == "show",
            dataAction: "create",
            isChanges: false
        };
    },
    created() {
        this.prepare();
        this.debounce = _.debounce(this.chainUnwatch, 10000);
    },
    mounted() {
        this.$refs.first_name.focus();
        this.debounce();
    },
    methods: {
        prepare() {
            this.getDepartments();

            if (this.$route.params.id) {
                this.dataAction = "edit";
                this.getObject();
            }
        },
        chainUnwatch() {
            this.unwatch = this.$watch(
                "dataObject",
                function(oldValue, newValue) {
                    if (newValue) {
                        this.isChanges = true;
                        this.unwatch();
                    }
                },
                { deep: true }
            );
        },
        getObject() {
            return axios
                .get("/api/user/get/" + this.$route.params.id)
                .then(res => {
                    this.dataObject = res.data;

                    if (this.dataObject.avatar) {
                        this.dataObject.avatar =
                            "/storage/users/" + this.dataObject.avatar;
                    } else {
                        this.dataObject.avatar = "/img/person_placeholder.jpg";
                    }
                })
                .catch(err => {
                    console.warn(err.message);
                });
        },
        onSubmit() {
            if (this.isSubmit) {
                return;
            }

            this.isSubmit = true;

            let formData = new FormData();

            formData.append("first_name", this.dataObject.first_name ?? "");
            formData.append("last_name", this.dataObject.last_name ?? "");
            formData.append("nick_name", this.dataObject.nick_name ?? "");
            formData.append("email", this.dataObject.email ?? "");
            formData.append(
                "department_id",
                this.dataObject.department.id ?? 0
            );
            formData.append("role", this.dataObject.role ?? "user");
            formData.append("image", this.dataObject.image ?? "");
            formData.append("reset_image", this.reset_image ?? false);

            if (this.isAction("create")) {
                axios
                    .post("/user", formData)
                    .then(res => {
                        Swal.fire("Saved!", "", "success").then(result => {
                            this.$router.push({
                                name: "UserIndex"
                            });
                        });
                    })
                    .catch(err => {
                        console.warn(err.response.data.errors);
                        Swal.fire("Error!", err.response.data.message, "error");
                    })
                    .then(res => {
                        this.isSubmit = false;
                    });
            } else if (this.isAction("edit")) {
                formData.append("_method", "patch");
                axios
                    .post("/user/" + this.dataObject.id, formData)
                    .then(res => {
                        Swal.fire("Updated!", "", "success");
                    })
                    .catch(err => {
                        console.warn(err.response.data.errors);
                        Swal.fire("Error!", err.response.data.message, "error");
                    })
                    .then(res => {
                        this.isSubmit = false;
                    });
            }
        },
        getDepartments() {
            axios
                .get("/api/department/all")
                .then(res => {
                    this.departments = res.data;
                })
                .catch(err => {
                    console.log(err.message);
                });
        },
        isAction(value) {
            return this.dataAction == value;
        },
        onImageChange(e) {
            let files = e.target.files || e.dataTransfer.files;
            if (files.length) {
                this.reset_image = false;
                this.dataObject.image = files[0];
                this.createImage(files[0]);
            }
        },
        onImageReset() {
            this.reset_image = true;
            this.dataObject.image = null;
            this.$refs.fileInput.value = null;
            this.dataObject.avatar = "/img/person_placeholder.jpg";
        },
        createImage(file) {
            let reader = new FileReader();
            reader.onload = e => {
                this.dataObject.avatar = e.target.result;
            };
            reader.readAsDataURL(file);
        },
        onExit() {
            if (this.isChanges) {
                Swal.fire({
                    title: "Do you want to exit?",
                    icon: "warning",
                    showCancelButton: true
                }).then(result => {
                    if (result.isConfirmed) {
                        this.$router.push({
                            name: "UserIndex"
                        });
                    }
                });
            } else {
                this.$router.push({
                    name: "UserIndex"
                });
            }
        }
    },

    computed: {}
};
</script>
